/* 
   Copyright 1994-2003 Free Software Foundation, Inc.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Lesser General Public
   License as published by the Free Software Foundation; either
   version 2.1 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Lesser General Public License for more details.

   You should have received a copy of the GNU Lesser General Public
   License along with this library; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 
   USA

   You may contact the author at:

   mailto::camille@bluegrass.net

   or by snail mail at:

   David Lindauer
   850 Washburn Ave Apt 99
   Louisville, KY 40222
*/
#include <stdlib.h>

void *_RTL_FUNC lfind(const void *key, const void *base, size_t *num, size_t width,
			int (*compare)(const void *elem1, const void *elem2))
{
	int i ;
	for (i=0; i < *num; i++)
		if ((*compare)(key, (char *)base + i * width) == 0)
			return (void *)((char *)base + i * width) ;
	return 0 ;
}
void *_RTL_FUNC _lfind(const void *key, const void *base, size_t *num, size_t width,
			int (*compare)(const void *elem1, const void *elem2))
{
	return lfind(key, base, num, width, compare);
}
void *_RTL_FUNC lsearch(const void *key, const void *base, size_t *num, size_t width,
			int (*compare)(const void *elem1, const void *elem2))
{
	void *rv = lfind(key,base,num,width,compare) ;
	char *pos ;
	if (rv)
		return rv ;
		
	pos = (char *)base + (*num) * width;
	memcpy(pos, key, width);
	(*num) ++ ;
	return pos;		
}
void *_RTL_FUNC _lsearch(const void *key, const void *base, size_t *num, size_t width,
			int (*compare)(const void *elem1, const void *elem2))
{
	return lsearch(key, base, num, width, compare);
}
